# Copyright 2014, Red Hat, Inc
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Authors:
#    Josef Skladanka <jskladan@redhat.com>


class Config(object):
    DEBUG = True
    SQLALCHEMY_DATABASE_URI = 'sqlite://'

    LOGFILE = '/var/log/vault/vault.log'
    FILE_LOGGING = False
    SYSLOG_LOGGING = False
    STREAM_LOGGING = True

    RUN_HOST = None
    RUN_PORT = None

    PRODUCTION = False
    TESTING = False

    SHOW_DB_URI = False

    MASTERKEY = 'svqAfvzMRcyasOmjLBxmwO+XgxnquC94pHEu59Ni1QE='

    RUN_HOST = '0.0.0.0'
    RUN_PORT = 4999

    OIDC_CLIENT_SECRETS = './conf/client_secrets.json.example'
    OIDC_ID_TOKEN_COOKIE_SECURE = False
    OIDC_REQUIRE_VERIFIED_EMAIL = False
    OVERWRITE_REDIRECT_URI = None
    OIDC_SCOPES = ['openid', 'email', 'profile', 'https://id.fedoraproject.org/scope/groups', 'https://id.fedoraproject.org/scope/cla', ]

class ProductionConfig(Config):
    DEBUG = False
    PRODUCTION = True
    OIDC_CLIENT_SECRETS = '/etc/vault/client_secrets.json'
    OIDC_ID_TOKEN_COOKIE_SECURE = True
    OVERWRITE_REDIRECT_URI = None


class DevelopmentConfig(Config):
    TRAP_BAD_REQUEST_ERRORS = True
    SQLALCHEMY_DATABASE_URI = 'sqlite:////tmp/vault_db.sqlite'


class TestingConfig(Config):
    TRAP_BAD_REQUEST_ERRORS = True
    TESTING = True
